import { isWeixin } from "./uni-env";
function _async(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }
    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}
function _call(body, then, direct) {
  if (direct) {
    return then ? then(body()) : body();
  }
  try {
    var result = Promise.resolve(body());
    return then ? result.then(then) : result;
  } catch (e) {
    return Promise.reject(e);
  }
}
export var getNavBarInfo = function getNavBarInfo() {
  var def = 44;
  return _call(getSystemInfo, function (sys) {
    var menu = getMenuButtonInfo();
    var navBarHeight = 0;
    var statusBarHeight = 0;
    if (isWeixin()) {
      if (menu.top && menu.height && sys != null && sys.statusBarHeight) {
        navBarHeight = (menu.top - sys.statusBarHeight) * 2 + menu.height + sys.statusBarHeight;
      }
    } else {
      navBarHeight = def;
    }
    statusBarHeight = sys.statusBarHeight || 0;
    return {
      navBarHeight: navBarHeight,
      statusBarHeight: statusBarHeight
    };
  });
};
export var getSystemInfo = _async(function () {
  return new Promise(function (resolve, reject) {
    try {
      uni.getSystemInfo({
        success: function success(value) {
          resolve(value);
        }
      });
    } catch (_unused) {
      reject();
    }
  });
});
export function getMenuButtonInfo() {
  var menuInfo = {
    height: 40,
    width: 0,
    top: 0,
    left: 0,
    right: 0,
    bottom: 0
  };
  if (isWeixin()) {
    return uni.getMenuButtonBoundingClientRect();
  }
  return menuInfo;
}