"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useInterval = useInterval;
var vue_1 = require("vue");
function useInterval(callback, delay) {
  var intervalId = (0, vue_1.ref)(null);
  (0, vue_1.watchEffect)(function () {
    var currentDelay = unref(delay);
    if (typeof currentDelay === 'number') {
      if (intervalId.value === null) {
        intervalId.value = setInterval(function () {
          callback();
        }, currentDelay);
      }
    } else {
      if (intervalId.value) {
        clearInterval(intervalId.value);
        intervalId.value = null;
      }
    }
  });
  // 提供一个直接停止的方法
  var stop = function stop() {
    if (intervalId.value) {
      clearInterval(intervalId.value);
      intervalId.value = null;
    }
  };
  return {
    stop: stop
  };
}
// 帮助函数，用于解开ref或返回原始值
function unref(refOrValue) {
  return isRef(refOrValue) ? refOrValue.value : refOrValue;
}
// 用于检查是否为ref的帮助函数
function isRef(refOrValue) {
  return !!refOrValue.value;
}